/*****************************************************************************
**																			**
**	 Name: 	Hello World!													**	
**																			**
******************************************************************************/

#include <cdefBF532.h>

/*****************************************************************************
 *
 *  Configures UART in 8 data bits, no parity, 1 stop bit mode.
 *
 ****************************************************************************/
void uart_init( int dd )
{
	*pUART_GCTL = UCEN;

	*pUART_LCR 	= DLAB;
	*pUART_DLL 	= dd;
	*pUART_DLH 	= dd>>8;

	*pUART_LCR 	= WLS(8);
}

/*****************************************************************************
 *
 *	This function transmits a character by polling THRE bit in the LSR
 *  register.
 *
 ****************************************************************************/
void uart_outbyte(char ch)
{
	int i;
	
	/* UART transmitter */
	for (i = 0; i < 10000; i++)
	{
		if (*pUART_LSR & 0x20)
			break;
	}

	*pUART_THR = ch;
}

/*****************************************************************************
 *
 *	This function transmits a byte string by polling THRE bit in the LSR
 *  register. The string must be NULL-terminated (C-style).
 *
 ****************************************************************************/
int uart_write( char *ptr, int len )
{
	while (len--)
	{
		if (*ptr == '\n')
			uart_outbyte('\r');
			
		uart_outbyte(*ptr++);
	}
	
	return 0;
}

/*****************************************************************************
 *
 *	Program entry point
 *
 ****************************************************************************/
int main()
{
	uart_init( 55 );

	while (1) 
		uart_write( "Hello World!\r\n", 14 );
	
	return 0;
}
